<html>
<head>
<title>OgreTangentSpaceCalc.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreTangentSpaceCalc.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreTangentSpaceCalc_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _OgreTangentSpaceCalc_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _OgreTangentSpaceCalc_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector2_8h.html">OgreVector2.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreVertexIndexData_8h.html">OgreVertexIndexData.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00048"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html" title="Class for calculating a tangent space basis.">TangentSpaceCalc</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">public</span>:
<a name="l00051"></a>00051         <a class="code" href="classOgre_1_1TangentSpaceCalc.html" title="Class for calculating a tangent space basis.">TangentSpaceCalc</a>();
<a name="l00052"></a>00052         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1TangentSpaceCalc.html" title="Class for calculating a tangent space basis.">TangentSpaceCalc</a>();
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">00054</a>         <span class="keyword">typedef</span> std::pair&lt;size_t, size_t&gt; <a class="code" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">VertexSplit</a>;
<a name="l00055"></a>00055 
<a name="l00057"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html">00057</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html" title="Information about a remapped index.">IndexRemap</a>
<a name="l00058"></a>00058         {
<a name="l00060"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a0b95b1be05110b59c87d44378f8f2d4b">00060</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a0b95b1be05110b59c87d44378f8f2d4b" title="Index data set (can be &gt;0 if more than one index data was added)">indexSet</a>;
<a name="l00062"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a477c9b282bb1275c79472224d890cab5">00062</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a477c9b282bb1275c79472224d890cab5" title="The position in the index buffer that&#39;s affected.">faceIndex</a>;
<a name="l00064"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a28ce54b6e709aa61689b4565cd0acf68">00064</a>             <a class="code" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">VertexSplit</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a28ce54b6e709aa61689b4565cd0acf68" title="The old and new vertex index.">splitVertex</a>;
<a name="l00065"></a>00065         
<a name="l00066"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a77c5b41921797ecfc47252bd99f789aa">00066</a>             <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a77c5b41921797ecfc47252bd99f789aa">IndexRemap</a>() {} <span class="comment">// to keep container happy</span>
<a name="l00067"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a6d5e329458cea922c5d62eaf814b4883">00067</a>             <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a6d5e329458cea922c5d62eaf814b4883">IndexRemap</a>(<span class="keywordtype">size_t</span> i, <span class="keywordtype">size_t</span> f, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">VertexSplit</a>&amp; s) : indexSet(i), faceIndex(f), splitVertex(s) {}
<a name="l00068"></a>00068         };
<a name="l00071"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a2ac32473675f968018e1dee1cbcf9cbe">00071</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;IndexRemap&gt;::type</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a2ac32473675f968018e1dee1cbcf9cbe" title="List of indexes that were remapped (split vertices).">IndexRemapList</a>;
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">00073</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;VertexSplit&gt;::type</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">VertexSplits</a>;
<a name="l00074"></a>00074 
<a name="l00076"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">00076</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html" title="The result of having built a tangent space basis.">Result</a>
<a name="l00077"></a>00077         {
<a name="l00082"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html#adc7a5f1543644476242dfad6552342b6">00082</a>             <a class="code" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">VertexSplits</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html#adc7a5f1543644476242dfad6552342b6" title="A list of vertex indices which were split off into new vertices because of mirroring.">vertexSplits</a>;
<a name="l00085"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html#a0e5e34d6936c7a3e76ad6e4d03688df8">00085</a>             <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a2ac32473675f968018e1dee1cbcf9cbe" title="List of indexes that were remapped (split vertices).">IndexRemapList</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html#a0e5e34d6936c7a3e76ad6e4d03688df8" title="A list of indexes which were affected by splits.">indexesRemapped</a>;
<a name="l00086"></a>00086         };
<a name="l00087"></a>00087 
<a name="l00089"></a>00089         <span class="keywordtype">void</span> clear();
<a name="l00090"></a>00090 
<a name="l00092"></a>00092         <span class="keywordtype">void</span> setVertexData(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* v_in);
<a name="l00093"></a>00093 
<a name="l00097"></a>00097         <span class="keywordtype">void</span> addIndexData(<a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* i_in, <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> opType = <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10da8c00ee152b44fe8000c2fd675437c087" title="A list of triangles, 3 vertices per triangle.">RenderOperation::OT_TRIANGLE_LIST</a>);
<a name="l00098"></a>00098 
<a name="l00111"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a637794857196e7b6bec4974b97ee5a50">00111</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a637794857196e7b6bec4974b97ee5a50" title="Sets whether to store tangent space parity in the W of a 4-component tangent or not.">setStoreParityInW</a>(<span class="keywordtype">bool</span> enabled) { mStoreParityInW = enabled; }
<a name="l00112"></a>00112 
<a name="l00114"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a00fec0ad7040d961755ad4300f848f3a">00114</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a00fec0ad7040d961755ad4300f848f3a" title="Gets whether to store tangent space parity in the W of a 4-component tangent or not.">getStoreParityInW</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mStoreParityInW; }
<a name="l00115"></a>00115 
<a name="l00130"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a43107313dd9e1fefb5a0f0760792ac45">00130</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a43107313dd9e1fefb5a0f0760792ac45" title="Sets whether or not to split vertices when a mirrored tangent space transition is detected (matrix pa...">setSplitMirrored</a>(<span class="keywordtype">bool</span> split) { mSplitMirrored = split; }
<a name="l00131"></a>00131         
<a name="l00135"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#ae67135b8fe3fde96af0f915bd36412cd">00135</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#ae67135b8fe3fde96af0f915bd36412cd" title="Gets whether or not to split vertices when a mirrored tangent space transition is detected...">getSplitMirrored</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSplitMirrored; }
<a name="l00136"></a>00136 
<a name="l00151"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a3b9ef4ec951f3a95e40697d7c6637a7d">00151</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a3b9ef4ec951f3a95e40697d7c6637a7d" title="Sets whether or not to split vertices when tangent space rotates more than 90 degrees around a vertex...">setSplitRotated</a>(<span class="keywordtype">bool</span> split) { mSplitRotated = split; }
<a name="l00155"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a3368c291e9891b0022442d7e2e74e1c0">00155</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a3368c291e9891b0022442d7e2e74e1c0" title="Sets whether or not to split vertices when tangent space rotates more than 90 degrees around a vertex...">getSplitRotated</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSplitRotated; }
<a name="l00156"></a>00156 
<a name="l00179"></a>00179         Result build(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> targetSemantic = <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da57d43012049b3ec7b4240b207dd029f2" title="Tangent (X axis if normal is Z)">VES_TANGENT</a>,
<a name="l00180"></a>00180             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceTexCoordSet = 0, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 1);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183     <span class="keyword">protected</span>:
<a name="l00184"></a>00184 
<a name="l00185"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#ada66de0f26b1df7521fc8f20dbda4718">00185</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="classOgre_1_1TangentSpaceCalc.html#ada66de0f26b1df7521fc8f20dbda4718">mVData</a>;
<a name="l00186"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a5aa76640242555497cf5decebb2eee97">00186</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;IndexData*&gt;::type</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a5aa76640242555497cf5decebb2eee97">IndexDataList</a>;
<a name="l00187"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a2cab27a58be8085742707d309d52a493">00187</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderOperation::OperationType&gt;::type</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a2cab27a58be8085742707d309d52a493">OpTypeList</a>;
<a name="l00188"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a7abe610c2dbc8256421979bc6e63ce47">00188</a>         <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a5aa76640242555497cf5decebb2eee97">IndexDataList</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a7abe610c2dbc8256421979bc6e63ce47">mIDataList</a>;
<a name="l00189"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a3a17076d70074dabd0884b14efaed6d0">00189</a>         <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a2cab27a58be8085742707d309d52a493">OpTypeList</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a3a17076d70074dabd0884b14efaed6d0">mOpTypes</a>;
<a name="l00190"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a17e748a306d6e8aa655573f425b1ee98">00190</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a17e748a306d6e8aa655573f425b1ee98">mSplitMirrored</a>;
<a name="l00191"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a09fcd46e2d234c9c967a394c96ed608c">00191</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a09fcd46e2d234c9c967a394c96ed608c">mSplitRotated</a>;
<a name="l00192"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a648fd36164397e42547bd3758018245d">00192</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a648fd36164397e42547bd3758018245d">mStoreParityInW</a>;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html">00195</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html">VertexInfo</a>
<a name="l00196"></a>00196         {
<a name="l00197"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a53e690638ce9f5661960a083d261db85">00197</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a53e690638ce9f5661960a083d261db85">pos</a>;
<a name="l00198"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#aa7ae945a733fadff16e4955389fb5278">00198</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#aa7ae945a733fadff16e4955389fb5278">norm</a>;
<a name="l00199"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a5d900bd283f3c9392870e69c9d6dccea">00199</a>             <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a5d900bd283f3c9392870e69c9d6dccea">uv</a>;
<a name="l00200"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a705c12ce272ffcb5eca147260c103a4c">00200</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a705c12ce272ffcb5eca147260c103a4c">tangent</a>;
<a name="l00201"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#ad7be8545889a2b044e00b96a8090fbeb">00201</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#ad7be8545889a2b044e00b96a8090fbeb">binormal</a>;
<a name="l00202"></a>00202             <span class="comment">// Which way the tangent space is oriented (+1 / -1) (set on first time found)</span>
<a name="l00203"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#abe5d125c575e64d4243ded38b3a02a33">00203</a>             <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#abe5d125c575e64d4243ded38b3a02a33">parity</a>;
<a name="l00204"></a>00204             <span class="comment">// What index the opposite parity vertex copy is at (0 if not created yet)</span>
<a name="l00205"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a1ac275a7c37232ca750b556ecaf8ef13">00205</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a1ac275a7c37232ca750b556ecaf8ef13">oppositeParityIndex</a>;
<a name="l00206"></a>00206 
<a name="l00207"></a><a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html#a3214bb9e83af1ceeb8c59a80b1424a50">00207</a>             <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html">VertexInfo</a>() : tangent(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), binormal(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), 
<a name="l00208"></a>00208                 parity(0), oppositeParityIndex(0) {}
<a name="l00209"></a>00209         };
<a name="l00210"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#af5204c42a779f3f8a71a8f06b4000d2b">00210</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;VertexInfo&gt;::type</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#af5204c42a779f3f8a71a8f06b4000d2b">VertexInfoArray</a>;
<a name="l00211"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#a43bd62c359203f882604b685b8a71176">00211</a>         <a class="code" href="classOgre_1_1TangentSpaceCalc.html#af5204c42a779f3f8a71a8f06b4000d2b">VertexInfoArray</a> <a class="code" href="classOgre_1_1TangentSpaceCalc.html#a43bd62c359203f882604b685b8a71176">mVertexArray</a>;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213         <span class="keywordtype">void</span> extendBuffers(<a class="code" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">VertexSplits</a>&amp; splits);
<a name="l00214"></a>00214         <span class="keywordtype">void</span> insertTangents(<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html" title="The result of having built a tangent space basis.">Result</a>&amp; res,
<a name="l00215"></a>00215             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> targetSemantic, 
<a name="l00216"></a>00216             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceTexCoordSet, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218         <span class="keywordtype">void</span> populateVertexArray(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceTexCoordSet);
<a name="l00219"></a>00219         <span class="keywordtype">void</span> processFaces(<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html" title="The result of having built a tangent space basis.">Result</a>&amp; result);
<a name="l00221"></a>00221         <span class="keywordtype">void</span> calculateFaceTangentSpace(<span class="keyword">const</span> <span class="keywordtype">size_t</span>* vertInd, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; tsU, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; tsV, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; tsN);
<a name="l00222"></a>00222         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculateAngleWeight(<span class="keywordtype">size_t</span> v0, <span class="keywordtype">size_t</span> v1, <span class="keywordtype">size_t</span> v2);
<a name="l00223"></a>00223         <span class="keywordtype">int</span> calculateParity(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; u, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; n);
<a name="l00224"></a>00224         <span class="keywordtype">void</span> addFaceTangentSpaceToVertices(<span class="keywordtype">size_t</span> indexSet, <span class="keywordtype">size_t</span> faceIndex, <span class="keywordtype">size_t</span> *localVertInd, 
<a name="l00225"></a>00225             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; faceTsU, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; faceTsV, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; faceNorm, <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html" title="The result of having built a tangent space basis.">Result</a>&amp; result);
<a name="l00226"></a>00226         <span class="keywordtype">void</span> normaliseVertices();
<a name="l00227"></a>00227         <span class="keywordtype">void</span> remapIndexes(<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html" title="The result of having built a tangent space basis.">Result</a>&amp; res);
<a name="l00228"></a>00228         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00229"></a><a class="code" href="classOgre_1_1TangentSpaceCalc.html#ab929ed3076f728b804f2115cd5f48853">00229</a>         <span class="keywordtype">void</span> remapIndexes(T* ibuf, <span class="keywordtype">size_t</span> indexSet, <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html" title="The result of having built a tangent space basis.">Result</a>&amp; res)
<a name="l00230"></a>00230         {
<a name="l00231"></a>00231             <span class="keywordflow">for</span> (IndexRemapList::iterator i = res.<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html#a0e5e34d6936c7a3e76ad6e4d03688df8" title="A list of indexes which were affected by splits.">indexesRemapped</a>.begin();
<a name="l00232"></a>00232                 i != res.<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1Result.html#a0e5e34d6936c7a3e76ad6e4d03688df8" title="A list of indexes which were affected by splits.">indexesRemapped</a>.end(); ++i)
<a name="l00233"></a>00233             {
<a name="l00234"></a>00234                 <a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html" title="Information about a remapped index.">IndexRemap</a>&amp; remap = *i;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236                 <span class="comment">// Note that because this is a vertex split situation, and vertex</span>
<a name="l00237"></a>00237                 <span class="comment">// split is only for some faces, it&#39;s not a case of replacing all</span>
<a name="l00238"></a>00238                 <span class="comment">// instances of vertex index A with vertex index B</span>
<a name="l00239"></a>00239                 <span class="comment">// It actually matters which triangle we&#39;re talking about, so drive</span>
<a name="l00240"></a>00240                 <span class="comment">// the update from the face index</span>
<a name="l00241"></a>00241 
<a name="l00242"></a>00242                 <span class="keywordflow">if</span> (remap.<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a0b95b1be05110b59c87d44378f8f2d4b" title="Index data set (can be &gt;0 if more than one index data was added)">indexSet</a> == indexSet)
<a name="l00243"></a>00243                 {
<a name="l00244"></a>00244                     T* pBuf;
<a name="l00245"></a>00245                     pBuf = ibuf + remap.<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a477c9b282bb1275c79472224d890cab5" title="The position in the index buffer that&#39;s affected.">faceIndex</a> * 3;
<a name="l00246"></a>00246 
<a name="l00247"></a>00247                     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> v = 0; v &lt; 3; ++v, ++pBuf)
<a name="l00248"></a>00248                     {
<a name="l00249"></a>00249                         <span class="keywordflow">if</span> (*pBuf == remap.<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a28ce54b6e709aa61689b4565cd0acf68" title="The old and new vertex index.">splitVertex</a>.first)
<a name="l00250"></a>00250                         {
<a name="l00251"></a>00251                             *pBuf = (T)remap.<a class="code" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#a28ce54b6e709aa61689b4565cd0acf68" title="The old and new vertex index.">splitVertex</a>.second;
<a name="l00252"></a>00252                         }
<a name="l00253"></a>00253                     }
<a name="l00254"></a>00254                 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257             }
<a name="l00258"></a>00258         }
<a name="l00259"></a>00259         
<a name="l00260"></a>00260 
<a name="l00261"></a>00261     };
<a name="l00265"></a>00265 }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
